# remirepo/Fedora spec file for php-zendframework-zend-mvc-plugin-fileprg
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    87184f33dbb98eb57c7338a5f026cca29bdd6048
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-mvc-plugin-fileprg
%global php_home     %{_datadir}/php
%global library      FilePrg
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.1.0
Release:        1%{?dist}
Summary:        Zend Framework Mvc-Plugin-%{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-reflection
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.5",
#        "zendframework/zend-coding-standard": "~1.0.0"
BuildRequires: (php-autoloader(%{gh_owner}/zend-filter)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-filter)           <  3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-form)             >= 2.7   with php-autoloader(%{gh_owner}/zend-form)             <  3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-inputfilter)      >= 2.8.1 with php-autoloader(%{gh_owner}/zend-inputfilter)      <  3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0   with php-autoloader(%{gh_owner}/zend-mvc)              <  4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-session)          >= 2.8.5 with php-autoloader(%{gh_owner}/zend-session)          <  3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)           <  4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-validator)        >= 2.6   with php-autoloader(%{gh_owner}/zend-validator)        <  3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-filter": "^2.6.1",
#        "zendframework/zend-form": "^2.7",
#        "zendframework/zend-inputfilter": "^2.8.1",
#        "zendframework/zend-mvc": "^3.0",
#        "zendframework/zend-session": "^2.8.5",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0",
#        "zendframework/zend-validator": "^2.6"
Requires:       php(language) >= 5.6
Requires:      (php-autoloader(%{gh_owner}/zend-filter)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-filter)           <  3)
Requires:      (php-autoloader(%{gh_owner}/zend-form)             >= 2.7   with php-autoloader(%{gh_owner}/zend-form)             <  3)
Requires:      (php-autoloader(%{gh_owner}/zend-inputfilter)      >= 2.8.1 with php-autoloader(%{gh_owner}/zend-inputfilter)      <  3)
Requires:      (php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0   with php-autoloader(%{gh_owner}/zend-mvc)              <  4)
Requires:      (php-autoloader(%{gh_owner}/zend-session)          >= 2.8.5 with php-autoloader(%{gh_owner}/zend-session)          <  3)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)           <  4)
Requires:      (php-autoloader(%{gh_owner}/zend-validator)        >= 2.6   with php-autoloader(%{gh_owner}/zend-validator)        <  3)
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.0.0
Requires:       php-reflection

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Provides a Post-Redirect-Get controller plugin for zend-mvc versions 3.0
and up, specifically for submissions that include file uploads.

If you want a generic PRG plugin without file upload support, see zend-mvc-plugin-prg.

* Issues at https://github.com/zendframework/zend-mvc-plugin-fileprg/issues
* Documentation is at https://zendframework.github.io/zend-mvc-plugin-fileprg/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Generate autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Filter/autoload.php',
    '%{php_home}/Zend/Form/autoload.php',
    '%{php_home}/Zend/InputFilter/autoload.php',
    '%{php_home}/Zend/Mvc/autoload.php',
    '%{php_home}/Zend/Session/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/Mvc/Plugin
cp -pr src %{buildroot}%{php_home}/Zend/Mvc/Plugin/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/Mvc/Plugin/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\Mvc\\Plugin\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/Mvc/Plugin/%{library}


%changelog
* Thu May  3 2018 Remi Collet <remi@remirepo.net> - 1.1.0-1
- update to 1.1.0
- use range dependencies
- switch to phpunit7
- raise dependency on zend-inputfilter 2.8.1
- raise dependency on zend-session 2.8.5

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Dec 13 2017 Remi Collet <remi@remirepo.net> - 1.0.0-4
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 1.0.0-1
- initial package

